package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwReverseOperationExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwReverseOperationExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkReverseIsNull() {
            addCriterion("PK_REVERSE is null");
            return (Criteria) this;
        }

        public Criteria andPkReverseIsNotNull() {
            addCriterion("PK_REVERSE is not null");
            return (Criteria) this;
        }

        public Criteria andPkReverseEqualTo(String value) {
            addCriterion("PK_REVERSE =", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseNotEqualTo(String value) {
            addCriterion("PK_REVERSE <>", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseGreaterThan(String value) {
            addCriterion("PK_REVERSE >", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseGreaterThanOrEqualTo(String value) {
            addCriterion("PK_REVERSE >=", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseLessThan(String value) {
            addCriterion("PK_REVERSE <", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseLessThanOrEqualTo(String value) {
            addCriterion("PK_REVERSE <=", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseLike(String value) {
            addCriterion("PK_REVERSE like", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseNotLike(String value) {
            addCriterion("PK_REVERSE not like", value, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseIn(List<String> values) {
            addCriterion("PK_REVERSE in", values, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseNotIn(List<String> values) {
            addCriterion("PK_REVERSE not in", values, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseBetween(String value1, String value2) {
            addCriterion("PK_REVERSE between", value1, value2, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkReverseNotBetween(String value1, String value2) {
            addCriterion("PK_REVERSE not between", value1, value2, "pkReverse");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIsNull() {
            addCriterion("PK_GLORGBOOK is null");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIsNotNull() {
            addCriterion("PK_GLORGBOOK is not null");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookEqualTo(String value) {
            addCriterion("PK_GLORGBOOK =", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotEqualTo(String value) {
            addCriterion("PK_GLORGBOOK <>", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookGreaterThan(String value) {
            addCriterion("PK_GLORGBOOK >", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookGreaterThanOrEqualTo(String value) {
            addCriterion("PK_GLORGBOOK >=", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLessThan(String value) {
            addCriterion("PK_GLORGBOOK <", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLessThanOrEqualTo(String value) {
            addCriterion("PK_GLORGBOOK <=", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookLike(String value) {
            addCriterion("PK_GLORGBOOK like", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotLike(String value) {
            addCriterion("PK_GLORGBOOK not like", value, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookIn(List<String> values) {
            addCriterion("PK_GLORGBOOK in", values, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotIn(List<String> values) {
            addCriterion("PK_GLORGBOOK not in", values, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookBetween(String value1, String value2) {
            addCriterion("PK_GLORGBOOK between", value1, value2, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPkGlorgbookNotBetween(String value1, String value2) {
            addCriterion("PK_GLORGBOOK not between", value1, value2, "pkGlorgbook");
            return (Criteria) this;
        }

        public Criteria andPeriodIsNull() {
            addCriterion("PERIOD is null");
            return (Criteria) this;
        }

        public Criteria andPeriodIsNotNull() {
            addCriterion("PERIOD is not null");
            return (Criteria) this;
        }

        public Criteria andPeriodEqualTo(String value) {
            addCriterion("PERIOD =", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotEqualTo(String value) {
            addCriterion("PERIOD <>", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodGreaterThan(String value) {
            addCriterion("PERIOD >", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodGreaterThanOrEqualTo(String value) {
            addCriterion("PERIOD >=", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodLessThan(String value) {
            addCriterion("PERIOD <", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodLessThanOrEqualTo(String value) {
            addCriterion("PERIOD <=", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodLike(String value) {
            addCriterion("PERIOD like", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotLike(String value) {
            addCriterion("PERIOD not like", value, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodIn(List<String> values) {
            addCriterion("PERIOD in", values, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotIn(List<String> values) {
            addCriterion("PERIOD not in", values, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodBetween(String value1, String value2) {
            addCriterion("PERIOD between", value1, value2, "period");
            return (Criteria) this;
        }

        public Criteria andPeriodNotBetween(String value1, String value2) {
            addCriterion("PERIOD not between", value1, value2, "period");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIsNull() {
            addCriterion("PK_VOUCHER is null");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIsNotNull() {
            addCriterion("PK_VOUCHER is not null");
            return (Criteria) this;
        }

        public Criteria andPkVoucherEqualTo(String value) {
            addCriterion("PK_VOUCHER =", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotEqualTo(String value) {
            addCriterion("PK_VOUCHER <>", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherGreaterThan(String value) {
            addCriterion("PK_VOUCHER >", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherGreaterThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHER >=", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLessThan(String value) {
            addCriterion("PK_VOUCHER <", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLessThanOrEqualTo(String value) {
            addCriterion("PK_VOUCHER <=", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherLike(String value) {
            addCriterion("PK_VOUCHER like", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotLike(String value) {
            addCriterion("PK_VOUCHER not like", value, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherIn(List<String> values) {
            addCriterion("PK_VOUCHER in", values, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotIn(List<String> values) {
            addCriterion("PK_VOUCHER not in", values, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherBetween(String value1, String value2) {
            addCriterion("PK_VOUCHER between", value1, value2, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andPkVoucherNotBetween(String value1, String value2) {
            addCriterion("PK_VOUCHER not between", value1, value2, "pkVoucher");
            return (Criteria) this;
        }

        public Criteria andReverseTypeIsNull() {
            addCriterion("REVERSE_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andReverseTypeIsNotNull() {
            addCriterion("REVERSE_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andReverseTypeEqualTo(String value) {
            addCriterion("REVERSE_TYPE =", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeNotEqualTo(String value) {
            addCriterion("REVERSE_TYPE <>", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeGreaterThan(String value) {
            addCriterion("REVERSE_TYPE >", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeGreaterThanOrEqualTo(String value) {
            addCriterion("REVERSE_TYPE >=", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeLessThan(String value) {
            addCriterion("REVERSE_TYPE <", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeLessThanOrEqualTo(String value) {
            addCriterion("REVERSE_TYPE <=", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeLike(String value) {
            addCriterion("REVERSE_TYPE like", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeNotLike(String value) {
            addCriterion("REVERSE_TYPE not like", value, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeIn(List<String> values) {
            addCriterion("REVERSE_TYPE in", values, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeNotIn(List<String> values) {
            addCriterion("REVERSE_TYPE not in", values, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeBetween(String value1, String value2) {
            addCriterion("REVERSE_TYPE between", value1, value2, "reverseType");
            return (Criteria) this;
        }

        public Criteria andReverseTypeNotBetween(String value1, String value2) {
            addCriterion("REVERSE_TYPE not between", value1, value2, "reverseType");
            return (Criteria) this;
        }

        public Criteria andOperatorIsNull() {
            addCriterion("OPERATOR is null");
            return (Criteria) this;
        }

        public Criteria andOperatorIsNotNull() {
            addCriterion("OPERATOR is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorEqualTo(String value) {
            addCriterion("OPERATOR =", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotEqualTo(String value) {
            addCriterion("OPERATOR <>", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorGreaterThan(String value) {
            addCriterion("OPERATOR >", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorGreaterThanOrEqualTo(String value) {
            addCriterion("OPERATOR >=", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorLessThan(String value) {
            addCriterion("OPERATOR <", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorLessThanOrEqualTo(String value) {
            addCriterion("OPERATOR <=", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorLike(String value) {
            addCriterion("OPERATOR like", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotLike(String value) {
            addCriterion("OPERATOR not like", value, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorIn(List<String> values) {
            addCriterion("OPERATOR in", values, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotIn(List<String> values) {
            addCriterion("OPERATOR not in", values, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorBetween(String value1, String value2) {
            addCriterion("OPERATOR between", value1, value2, "operator");
            return (Criteria) this;
        }

        public Criteria andOperatorNotBetween(String value1, String value2) {
            addCriterion("OPERATOR not between", value1, value2, "operator");
            return (Criteria) this;
        }

        public Criteria andOperationtimeIsNull() {
            addCriterion("OPERATIONTIME is null");
            return (Criteria) this;
        }

        public Criteria andOperationtimeIsNotNull() {
            addCriterion("OPERATIONTIME is not null");
            return (Criteria) this;
        }

        public Criteria andOperationtimeEqualTo(Date value) {
            addCriterion("OPERATIONTIME =", value, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeNotEqualTo(Date value) {
            addCriterion("OPERATIONTIME <>", value, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeGreaterThan(Date value) {
            addCriterion("OPERATIONTIME >", value, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeGreaterThanOrEqualTo(Date value) {
            addCriterion("OPERATIONTIME >=", value, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeLessThan(Date value) {
            addCriterion("OPERATIONTIME <", value, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeLessThanOrEqualTo(Date value) {
            addCriterion("OPERATIONTIME <=", value, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeIn(List<Date> values) {
            addCriterion("OPERATIONTIME in", values, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeNotIn(List<Date> values) {
            addCriterion("OPERATIONTIME not in", values, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeBetween(Date value1, Date value2) {
            addCriterion("OPERATIONTIME between", value1, value2, "operationtime");
            return (Criteria) this;
        }

        public Criteria andOperationtimeNotBetween(Date value1, Date value2) {
            addCriterion("OPERATIONTIME not between", value1, value2, "operationtime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}